CREATE OR REPLACE FUNCTION ARQUIVO_DCTF_R25 (
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_SITUACAO     IN NOTAFISCAL.IDSTATUS%TYPE,
   V_IRPJ         VARCHAR2,
   V_IRRF         VARCHAR2,
   V_IPI          VARCHAR2,
   V_IOF          VARCHAR2,
   V_CSLL         VARCHAR2,
   V_PIS          VARCHAR2,
   V_COFINS       VARCHAR2,
   V_CPMF         VARCHAR2,
   V_CIDE         VARCHAR2,
   V_RET          VARCHAR2,
   V_CSRF         VARCHAR2,
   V_COSIRF       VARCHAR2,
   V_CPSSS        VARCHAR2)RETURN NUMBER
AS 
   V_CONTREGAR25   NUMBER;
   V_CDRECEITA    VARCHAR2(6);
BEGIN
   FOR C_REG_25_IRPJ IN (SELECT (RPAD('R25',3,' '))                                                                           ||/*REGISTRO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ*/
                                TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMM')                                                        ||/*ANO/MES*/
                                P_SITUACAO                                                                                    ||/*SITUACAO*/
                                DECODE(P_SITUACAO,'0',RPAD('0',8,'0'), TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMMDD'))              ||/*DATA DO EVENTO*/
                                V_IRPJ                                                                                        ||/*TRIBUTO*/
                                NVL(NVL(CDRECEITACONTR,CDRECEGUIA)||CDVARIACAO,'000000')                                      ||/*CODIGO DA RECEITA*/
                                IDPERIODICREC                                                                                 ||/*PERIODICIDADE*/
                                TO_CHAR(DTFIMPERIODO,'YYYY')                                                                  ||/*ANO DE APURACAO*/
                                DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'03','01',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'06','02',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'09','03','04')))||/*TRIMESTRE*/
                                '00'                                                                                          ||/*RESERVADO*/
                                RPAD('0',6,0)                                                                                 ||/*RESERVADO*/
                                RPAD('0',14,0)                                                                                ||/*RESERVADO*/
                                '0'                                                                                           ||/*RESERVADO*/
                                RPAD(NVL(NRPROCESSOGUIA,' '),21,' ')                                                          ||/*N PROCESSO*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(VRPARCELA,'000000000000.00'),'.')),'14','0')                       ||/*VALOR PARCELADO DO DEBITO*/
                                RPAD(' ',10,' ')    AS REG_25_IRPJ
                           FROM (SELECT SUM(VRORIGPAG) AS VRPARCELA, E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC, MP.CDRECEITACONTR,
                                        MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG, MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO
                                   FROM EMPRESA E , MAPAAPURAC MP, GUIACOMPLMAPA G, CONTAPAGAR CP
                                  WHERE MP.CDEMPRESA    = E.CDEMPRESA
                                    AND E.CDEMPRESA     = P_CDEMPRESA
                                    AND TO_CHAR(TO_DATE(P_DTFINAL),'MM') IN ('03','06','09','12')
                                    AND MP.DTINIPERIODO = ADD_MONTHS(P_DTINICIAL,-5)
                                    AND MP.DTFIMPERIODO = ADD_MONTHS(P_DTFINAL,-3)
                                    AND MP.CDIMPOSTO    = '25'
                                    AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU(+)
                                    AND CP.DSCONTAPAG   = MP.NMMAPAAPUR
                                  GROUP BY E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC, MP.CDRECEITACONTR,
                                        MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG))LOOP
      V_CONTREGAR25 := NVL(V_CONTREGAR25,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('2042'||LPAD(RTRIM(V_CONTREGAR25), 6, '0'), C_REG_25_IRPJ.REG_25_IRPJ, P_NRSEQARQMAG);
   END LOOP;

   FOR C_REG_25_CSLL IN (SELECT (RPAD('R25',3,' '))                                                                           ||/*REGISTRO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ*/
                                TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMM')                                                        ||/*ANO/MES*/
                                P_SITUACAO                                                                                    ||/*SITUACAO*/
                                DECODE(P_SITUACAO,'0',RPAD('0',8,'0'), TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMMDD'))              ||/*DATA DO EVENTO*/
                                V_CSLL                                                                                        ||/*TRIBUTO*/
                                NVL(NVL(CDRECEITACONTR,CDRECEGUIA)||CDVARIACAO,'000000')                                      ||/*CODIGO DA RECEITA*/
                                IDPERIODICREC                                                                                 ||/*PERIODICIDADE*/
                                TO_CHAR(DTFIMPERIODO,'YYYY')                                                                  ||/*ANO DE APURACAO*/
                                DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'03','01',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'06','02',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'09','03','04')))||/*TRIMESTRE*/
                                '00'                                                                                          ||/*RESERVADO*/
                                RPAD('0',6,0)                                                                                 ||/*RESERVADO*/
                                RPAD('0',14,0)                                                                                ||/*RESERVADO*/
                                '0'                                                                                           ||/*RESERVADO*/
                                RPAD(NVL(NRPROCESSOGUIA,' '),21,' ')                                                          ||/*N PROCESSO*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(VRPARCELA,'000000000000.00'),'.')),'14','0')                       ||/*VALOR PARCELADO DO DEBITO*/
                                RPAD(' ',10,' ')    AS REG_25_CSLL
                           FROM (SELECT SUM(VRORIGPAG) AS VRPARCELA,E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC, MP.CDRECEITACONTR,
                                        MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG, MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO
                                   FROM EMPRESA E , MAPAAPURAC MP, GUIACOMPLMAPA G, CONTAPAGAR CP
                                  WHERE MP.CDEMPRESA    = E.CDEMPRESA
                                    AND E.CDEMPRESA     = P_CDEMPRESA
                                    AND TO_CHAR(TO_DATE(P_DTFINAL),'MM') IN ('03','06','09','12')
                                    AND MP.DTINIPERIODO = ADD_MONTHS(P_DTINICIAL,-5)
                                    AND MP.DTFIMPERIODO = ADD_MONTHS(P_DTFINAL,-3)
                                    AND MP.CDIMPOSTO    = '70'
                                    AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU(+)
                                    AND CP.DSCONTAPAG   = MP.NMMAPAAPUR
                                  GROUP BY E.NRINSJUREMPR, MP.CDVARIACAO , MP.IDPERIODICREC, MP.CDRECEITACONTR,
                                        MP.CDRECEGUIA, MP.IDDEBSCPINC, G.NRPROCESSOGUIA, NRPARCELAPAG))LOOP
      V_CONTREGAR25 := NVL(V_CONTREGAR25,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('2102'||LPAD(RTRIM(V_CONTREGAR25), 6, '0'), C_REG_25_CSLL.REG_25_CSLL, P_NRSEQARQMAG);
   END LOOP;
   RETURN V_CONTREGAR25 ;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DCTF_R25','5.03.034'); END;
/