CREATE OR REPLACE FUNCTION BUSCA_TOLERANCIA_CNC(P_PROD IN NUMBER, P_ADQ IN NUMBER) RETURN FLOAT
AS
   V_NUMTEMP NUMBER;
BEGIN
   V_NUMTEMP := -1;
   /* BUSCA A TAXA ESPECFICA DE UM PRODUTO*/
   BEGIN
      SELECT NVL(VRTOLERANCIA, -1)
        INTO V_NUMTEMP
        FROM PRODUTOADQ
       WHERE NRPRODUTOADQ = P_PROD;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_NUMTEMP := -1;
   END;
   /* CASO NO TENHA UMA TAXA ESPECFICA, A ROTINA BUSCA DA ADQUIRENTE */
   IF V_NUMTEMP = -1 THEN
      BEGIN
         SELECT NVL(VRTOLERANCIA, -1)
           INTO V_NUMTEMP
           FROM ADQUIRENTE
          WHERE NRADQUIRENTE = P_ADQ;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NUMTEMP := -1;
      END;
   END IF;
   IF V_NUMTEMP = -1 THEN
      V_NUMTEMP := 0;
   END IF;
   RETURN V_NUMTEMP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_TOLERANCIA_CNC','6.10.000'); END;
/

