/* Retorna a conta contbil */

CREATE OR REPLACE FUNCTION USR_CONTPROD
   (P_CDTIPOOPER   IN NOTAFISCAL.CDTIPOOPER%TYPE,
    P_IDENTRSAIDOP IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
    P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE) RETURN PRODUTO.CDCTBLSAIDPR%TYPE
AS
   V_CDCONTABIL PRODUTO.CDCTBLSAIDPR%TYPE;
   V_CDCONTREDU CONTCTBL.CDCONTREDU%TYPE;
BEGIN
   IF NOT (P_CDTIPOOPER IS NULL) THEN
      SELECT CDCONTPROD
      INTO V_CDCONTABIL
      FROM TIPOOPERAC T
      WHERE CDTIPOOPER   = P_CDTIPOOPER   AND
            IDENTRSAIDOP = P_IDENTRSAIDOP;
   END IF;

   IF V_CDCONTABIL IS NULL THEN
      IF P_IDENTRSAIDOP = 'E' THEN
         SELECT MAX(CDCTBLENTRPR)
         INTO V_CDCONTABIL
         FROM  PRODUTO C
         WHERE (INSTR(P_CDPRODUTO,RTRIM(C.CDPRODUTO)) = 1) AND
               NOT (CDCTBLENTRPR IS NULL);
      ELSE
         SELECT MAX(CDCTBLSAIDPR)
         INTO V_CDCONTABIL
         FROM  PRODUTO C
         WHERE (INSTR(P_CDPRODUTO,RTRIM(C.CDPRODUTO)) = 1) AND
               NOT (CDCTBLSAIDPR IS NULL);
      END IF;
   END IF;

   SELECT CDCONTREDU
   INTO V_CDCONTREDU
   FROM CONTCTBL
   WHERE CDCONTCTBL = RTRIM(V_CDCONTABIL);

   RETURN(V_CDCONTREDU);
END;

/

/* Retorna o nmero do mapa resumo */

CREATE OR REPLACE FUNCTION USR_MAPARESUMO
   (P_CDFILIAL  IN VENDA.CDFILIAL%TYPE,
    P_CDCAIXA   IN VENDA.CDCAIXA%TYPE,
    P_DTVENDA   IN VENDA.DTENTRVENDA%TYPE) RETURN NOTAFISCAL.NRNOTAFISC%TYPE
AS
   V_NRNOTAFISC NOTAFISCAL.NRNOTAFISC%TYPE;
BEGIN
   SELECT MIN(DISTINCT NF.NRNOTAFISC)
   INTO V_NRNOTAFISC
   FROM VENDA VD, ITEMVENDA IT, NOTAFISCAL NF
   WHERE (VD.CDFILIAL    = P_CDFILIAL)     AND
         (VD.CDCAIXA     = P_CDCAIXA)      AND
         (VD.DTENTRVENDA = P_DTVENDA)      AND
         (VD.IDSITUVENDA = 'O')            AND
         (VD.IDTIPOVENDA IN ('C', 'I', 'S', 'D')) AND
         (IT.CDFILIAL    = VD.CDFILIAL)    AND
         (IT.CDCAIXA     = VD.CDCAIXA)     AND
         (IT.NRSEQVENDA  = VD.NRSEQVENDA)  AND
         (NF.CDFILIAL    = IT.CDFILIALNF)  AND
         (NF.NRLANCTONF  = IT.NRLANCTONF);

   RETURN (V_NRNOTAFISC);

END;
/

CREATE OR REPLACE FUNCTION USR_CFOPITEM
   (P_CDFILIAL   IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_NRLANCTONF IN ITEMPRODUTO.NRLANCTONF%TYPE,
    P_CDPRODUTO  IN ITEMPRODUTO.CDPRODUTO%TYPE ) RETURN ITEMPRODUTO.CDFISOPEITEM%TYPE
AS
   V_CFOPITEM ITEMPRODUTO.CDFISOPEITEM%TYPE;
BEGIN
   SELECT MAX(CDFISOPEITEM)
   INTO V_CFOPITEM
   FROM ITEMPRODUTO
   WHERE CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF AND
         CDPRODUTO  = P_CDPRODUTO ;

   IF V_CFOPITEM IS NULL THEN
      SELECT MAX(CDFISOPEITEM)
      INTO V_CFOPITEM
      FROM ITEMPRODUTO I, ROTFABRICA R
      WHERE I.CDFILIAL      = P_CDFILIAL   AND
            I.NRLANCTONF    = P_NRLANCTONF AND
            R.CDSUBPRODUTO  = P_CDPRODUTO  AND
            I.CDPRODUTO     = R.CDPRODUTO ;
   END IF;
   RETURN (V_CFOPITEM);
END;
/

CREATE OR REPLACE FUNCTION USR_CSTITEM
   (P_CDFILIAL   IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_NRLANCTONF IN ITEMPRODUTO.NRLANCTONF%TYPE,
    P_CDPRODUTO  IN ITEMPRODUTO.CDPRODUTO%TYPE ) RETURN ITEMPRODUTO.CDFISOPEITEM%TYPE
AS
   V_CSTITEM ITEMPRODUTO.CDSITUTRIBPR%TYPE;
BEGIN
   SELECT MAX(CDSITUTRIBPR)
     INTO V_CSTITEM
     FROM ITEMPRODUTO
    WHERE CDFILIAL   = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF
      AND CDPRODUTO  = P_CDPRODUTO;

   IF V_CSTITEM IS NULL THEN
      SELECT MAX(CDSITUTRIBPR)
        INTO V_CSTITEM
        FROM ITEMPRODUTO I, ROTFABRICA R
       WHERE I.CDFILIAL     = P_CDFILIAL
         AND I.NRLANCTONF   = P_NRLANCTONF
         AND R.CDSUBPRODUTO = P_CDPRODUTO
         AND I.CDPRODUTO    = R.CDPRODUTO;
   END IF;
   RETURN (V_CSTITEM);
END;
/

CREATE OR REPLACE FUNCTION USR_VRTOTIPI
   (P_CDFILIAL    IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_NRLANCTONF  IN ITEMPRODUTO.NRLANCTONF%TYPE,
    P_NRSEQITPROD IN ITEMPRODUTO.NRSEQITPROD%TYPE) RETURN ITEMPROIMPOS.VRIMPOSTOIT%TYPE
AS
   V_VRTOTIPI ITEMPROIMPOS.VRIMPOSTOIT%TYPE;
BEGIN
   SELECT SUM(VRIMPOSTOIT)
     INTO V_VRTOTIPI
     FROM ITEMPROIMPOS
    WHERE CDFILIAL = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF
      AND NRSEQITPROD = P_NRSEQITPROD
      AND CDIMPOSTO = '10';

   RETURN (V_VRTOTIPI);
END;
/

CREATE OR REPLACE FUNCTION USR_FLAGD1
   (P_CDFILIAL    IN FILIAL.CDFILIAL%TYPE,
    P_DTREDUCAOZ  IN REDUCAOZ.DTREDUCAOZ%TYPE,
    P_VRNOTAFISC  IN NOTAFISCAL.VRNOTAFISC%TYPE) RETURN VARCHAR
AS
   V_VALORLIQ FLOAT;
   V_FLAGD1   VARCHAR2(02);
BEGIN
   V_VALORLIQ := 0;
   V_FLAGD1   := '';

   SELECT SUM((QTPRODVEND * VRUNITVEND) - NVL(VRDESITVEND, 0) + NVL(VRACRITVEND, 0))
     INTO V_VALORLIQ
     FROM VENDA V, ITEMVENDA I
    WHERE V.CDFILIAL = P_CDFILIAL
      AND V.DTENTRVENDA = P_DTREDUCAOZ
      AND V.IDSITUVENDA = 'O'
      AND I.CDFILIAL = V.CDFILIAL
      AND I.CDCAIXA  = V.CDCAIXA
      AND I.NRSEQVENDA = V.NRSEQVENDA;

   IF ROUND(NVL(V_VALORLIQ, 0),2) <> ROUND(P_VRNOTAFISC,2) THEN
      V_FLAGD1 := 'D1';
   ELSE
      V_FLAGD1 := '';
   END IF;

   RETURN (V_FLAGD1);
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('USR_VRTOTIPI','5.60.XXX'); END;
/

