/* Tabela NOTAFISCAL: Cadastro de AJUSTE DE CONTAS A RECEBER */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela AJCTRECEBER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela AJUSTE DE CONTAS A RECEBER,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_FIN_AJCTRECEBER' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_FIN_AJCTRECEBER
GO
CREATE TRIGGER LOG_FIN_AJCTRECEBER
ON AJCTRECEBER
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDAJUCTREC_NEW      VARCHAR(20);
  DECLARE @V_DSAJUSTEREC_NEW     VARCHAR(30);
  DECLARE @V_NRPARCELAREC_NEW    VARCHAR(30);
  DECLARE @V_NRSEQVENREC_NEW     VARCHAR(1);

  DECLARE @V_DTAJUSTEREC_NEW       DATETIME;
  DECLARE @V_VRAJUSTEREC_NEW     NUMERIC;


  DECLARE @V_CDAJUCTREC_OLD      VARCHAR(20);
  DECLARE @V_DSAJUSTEREC_OLD     VARCHAR(30);
  DECLARE @V_NRPARCELAREC_OLD    VARCHAR(30);
  DECLARE @V_NRSEQVENREC_OLD     VARCHAR(1);

  DECLARE @V_DTAJUSTEREC_OLD       DATETIME;
  DECLARE @V_VRAJUSTEREC_OLD      NUMERIC;


  DECLARE @V_CDFILIAL_OLD        VARCHAR(4);
  DECLARE @V_NRLANCTONF_OLD      VARCHAR(10);
  DECLARE @V_CDFILIAL_NEW        VARCHAR(4);
  DECLARE @V_NRLANCTONF_NEW      VARCHAR(10);

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO = '-';


   DECLARE C_CURSOR_CR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL,NULL, NULL, NULL, NULL, NULL, NULL,
         CDFILIAL,
         NRLANCTONF,
         CDAJUCTREC,
         DSAJUSTEREC,
         NRPARCELAREC,
         NRSEQVENREC,
         DTAJUSTEREC,
         VRAJUSTEREC
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.NRLANCTONF,
         INSERTED.CDAJUCTREC,
         INSERTED.DSAJUSTEREC,
         INSERTED.NRPARCELAREC,
         INSERTED.NRSEQVENREC,
         INSERTED.DTAJUSTEREC,
         INSERTED.VRAJUSTEREC,
         DELETED.CDFILIAL,
         DELETED.NRLANCTONF,
         DELETED.CDAJUCTREC,
         DELETED.DSAJUSTEREC,
         DELETED.NRPARCELAREC,
         DELETED.NRSEQVENREC,
         DELETED.DTAJUSTEREC,
         DELETED.VRAJUSTEREC
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL    = DELETED.CDFILIAL    AND
         INSERTED.NRLANCTONF  = DELETED.NRLANCTONF

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.NRLANCTONF,
         INSERTED.CDAJUCTREC,
         INSERTED.DSAJUSTEREC,
         INSERTED.NRPARCELAREC,
         INSERTED.NRSEQVENREC,
         INSERTED.DTAJUSTEREC,
         INSERTED.VRAJUSTEREC,
         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_CR;
   FETCH NEXT FROM C_CURSOR_CR   INTO @V_TIPO, @V_CDFILIAL_NEW, @V_NRLANCTONF_NEW,@V_CDAJUCTREC_NEW,
                                      @V_DSAJUSTEREC_NEW, @V_NRPARCELAREC_NEW, @V_NRSEQVENREC_NEW,
                                      @V_DTAJUSTEREC_NEW, @V_VRAJUSTEREC_NEW,


                                      @V_CDFILIAL_OLD, @V_NRLANCTONF_OLD, @V_CDAJUCTREC_OLD,
                                      @V_DSAJUSTEREC_OLD,@V_NRPARCELAREC_OLD,@V_NRSEQVENREC_OLD,
                                      @V_DTAJUSTEREC_OLD,  @V_VRAJUSTEREC_OLD;


   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_TIPO = 'D' BEGIN
         IF @V_CDAJUCTREC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Codigo=' + @V_CDAJUCTREC_OLD;
         END;

         IF @V_DSAJUSTEREC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descricao=' + @V_DSAJUSTEREC_OLD;
         END;

         IF @V_NRPARCELAREC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Parcelas=' + @V_NRPARCELAREC_OLD;
         END;

         IF @V_NRSEQVENREC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrseqVenc=' + @V_NRSEQVENREC_OLD;
         END;

         IF @V_DTAJUSTEREC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Dt. Ajuste=' + CONVERT(VARCHAR,@V_DTAJUSTEREC_OLD);
         END;

         IF @V_VRAJUSTEREC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Valor=' + CONVERT(VARCHAR,@V_VRAJUSTEREC_OLD);
         END;

         SET @V_TPMOVI       = '3';
         SET @V_ITPESQ       = @V_CDFILIAL_OLD+@V_NRLANCTONF_OLD;
         SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
            IF (@V_CDAJUCTREC_OLD   <> @V_CDAJUCTREC_NEW)   OR
               (@V_DSAJUSTEREC_OLD  <> @V_DSAJUSTEREC_NEW)  OR
               (@V_NRPARCELAREC_OLD <> @V_NRPARCELAREC_NEW) OR
               (@V_NRSEQVENREC_OLD  <> @V_NRSEQVENREC_NEW)  OR
               (@V_DTAJUSTEREC_OLD    <> @V_DTAJUSTEREC_NEW)OR
               (@V_VRAJUSTEREC_OLD  <> @V_VRAJUSTEREC_NEW) BEGIN

               SET @V_TPMOVI       = '2';
               SET @V_ITPESQ       = @V_CDFILIAL_OLD+@V_NRLANCTONF_OLD;
               SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI        = '1';
            SET @V_ITPESQ        = @V_CDFILIAL_NEW+@V_NRLANCTONF_NEW;
            SET @V_CDFILLOGOPER  = @V_CDFILIAL_NEW;
         END;

         IF @V_CDAJUCTREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Codigo=' + @V_CDAJUCTREC_NEW;
         END;

         IF @V_DSAJUSTEREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descricao=' + @V_DSAJUSTEREC_NEW;
         END;

         IF @V_NRPARCELAREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Parcelas=' + @V_NRPARCELAREC_NEW;
         END;

         IF @V_NRSEQVENREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrseqVenc=' + @V_NRSEQVENREC_NEW;
         END;

         IF @V_DTAJUSTEREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Dt. Ajuste=' + CONVERT(VARCHAR,@V_DTAJUSTEREC_NEW);
         END;

         IF @V_VRAJUSTEREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Valor=' + CONVERT(VARCHAR,@V_VRAJUSTEREC_NEW);
         END;

      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   CDFILLOGOPER,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('AJCTRECEBER',
                   @V_DTOPER,
                   @V_USUARIO,
                   @V_TPMOVI,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,300),
                   @V_CDFILLOGOPER,
                   @V_DSSERVERRDM,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR_CR   INTO @V_TIPO, @V_CDFILIAL_NEW, @V_NRLANCTONF_NEW, @V_CDAJUCTREC_NEW,
                                         @V_DSAJUSTEREC_NEW, @V_NRPARCELAREC_NEW, @V_NRSEQVENREC_NEW,
                                         @V_DTAJUSTEREC_NEW, @V_VRAJUSTEREC_NEW,

                                         @V_CDFILIAL_OLD, @V_NRLANCTONF_OLD,@V_CDAJUCTREC_OLD,
                                         @V_DSAJUSTEREC_OLD,@V_NRPARCELAREC_OLD, @V_NRSEQVENREC_OLD,
                                         @V_DTAJUSTEREC_OLD,@V_VRAJUSTEREC_OLD;
   END;
   CLOSE C_CURSOR_CR;
   DEALLOCATE C_CURSOR_CR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_AJUSCTRECEBER','4.11.128';
GO
